%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function define
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [w, theta] = CalWCpCn(ptn, n_num)

    [ptn_h ptn_w] = size(ptn);

	
	[bitUp bitUn] = CalbitU(ptn);
	
	
	%%%%%%%%%%%%%%%%%%%%%
	%
	% start to calculate C.
	%
	%%%%%%%%%%%%%%%%%%%%%
	Cp = [];
	Cn = [];
	for i=1:n_num
        Up = bitUp{i};
        Un = bitUn{i};
        
        if(~isempty(Up))
            tmp = ptn(:,Up)*ptn(:,Up)';
            Cpi = tmp(i,:)/length(Up);
            Cp(i,:) = Cpi;
        else
            Cp(i,:) = zeros(1,n_num);
		end
        
        if(~isempty(Un))
            tmp = ptn(:,Un)*ptn(:,Un)';
            Cni = tmp(i,:)/length(Un);
            Cn(i,:) = Cni;
        else
            Cn(i,:) = zeros(1,n_num);
		end
        tmp = [];
        
        
        
        %%%%%%%%%%%%%%%%%
        % calculate weight by equal 1.
        %%%%%%%%%%%%%%%%%
        W(i,:) = Cp(i,:)+Cn(i,:);
        
         % normalize
        W(i,:) = W(i,:)/norm(W(i,:));
        
        if(isempty(Up))    % all pattern have the same sign, shift the plane out of the cube.
            theta(i) = 100;
        elseif(isempty(Un))
            theta(i) = -100;
        else
            theta(i) = W(i,:)*(Cp(i,:)-Cn(i,:))'/2;
        end
	end % end of for i=1:n_num

w = W;

